﻿class Bouncer extends MovieClip {
	// variables, all private - internally handled
	private var gravity:Number = 0;
	private var boundries:Object;
	private var velocity_x:Number;
	private var velocity_y:Number;
	private var original_x:Number;
	private var original_y:Number;
	
	// constructor
	function Bouncer() {
		original_x = _x;
		original_y = _y;
		Mouse.addListener(this);
		onMouseDown(); // force mouseDown event
	}
	
	// init method for arguments which in other normal
	// circumstances (non-MovieClip classes) would be
	// given to the constructor. Not an option with MovieClips
	function init (pGravity:Number, pBoundries:Object) {
		gravity = pGravity;
		boundries = pBoundries;
		return this;
	}
	// onEnterFrame event to control bouncing
	private function onEnterFrame():Void {
		// move ball
		_x += velocity_x;
		_y += velocity_y;
		
		// check for boundry collision
		if (_x <= boundries.left) {
			_x = boundries.left;
			velocity_x = Math.abs(velocity_x);
		}else if (_x >= boundries.right) {
			_x = boundries.right;
			velocity_x = -Math.abs(velocity_x);
		}
		if (_y <= boundries.top) {
			_y = boundries.top;
			velocity_y = Math.abs(velocity_y);
		}else if (_y >= boundries.bottom) {
			_y = boundries.bottom;
			velocity_y = -Math.abs(velocity_y);
		}
		
		// apply gravity
		velocity_y += gravity;
	}
	
	// reset original position and apply a new
	// random direction when the mouse is pressed
	private function onMouseDown():Void {
		_x = original_x;
		_y = original_y;
		velocity_x = Math.random()*20-10;
		velocity_y = -Math.random()*20;
	}
}